import { ConfigActionType, actionResult, qpqCoreUtils, } from 'quidproquo-core';
import { resolveParameterKey } from '../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils';
import { getParameter } from '../../../logic/parametersManager/getParameter';
const getProcessConfigGetParameter = (qpqConfig) => {
    return async ({ parameterName }) => {
        const awsParameterKey = resolveParameterKey(parameterName, qpqConfig);
        const parameterValue = await getParameter(awsParameterKey, qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig));
        return actionResult(parameterValue);
    };
};
export default (qpqConfig) => {
    return {
        [ConfigActionType.GetParameter]: getProcessConfigGetParameter(qpqConfig),
    };
};
