import { ConfigActionType, actionResult, qpqCoreUtils, } from 'quidproquo-core';
import { resolveParameterKey } from '../../../runtimeConfig/qpqAwsLambdaRuntimeConfigUtils';
import { getParameters } from '../../../logic/parametersManager/getParameters';
const getProcessConfigGetParameters = (qpqConfig) => {
    return async ({ parameterNames }) => {
        const awsParameterKeys = parameterNames.map((pn) => resolveParameterKey(pn, qpqConfig));
        const parameterValues = await getParameters(awsParameterKeys, qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig));
        return actionResult(parameterValues);
    };
};
export default (qpqConfig) => {
    return {
        [ConfigActionType.GetParameters]: getProcessConfigGetParameters(qpqConfig),
    };
};
