import { ErrorTypeEnum, EventActionType, actionResult, actionResultError, qpqCoreUtils, } from 'quidproquo-core';
import { EmailSendEventType } from 'quidproquo-webserver';
// TODO: Don't use Globals like this
const GLOBAL_USER_DIRECTORY_NAME = process.env.userDirectoryName;
const getProcessMatchStory = (qpqConfig) => {
    const userDirectoryConfig = qpqCoreUtils.getUserDirectories(qpqConfig).find((ud) => ud.name === GLOBAL_USER_DIRECTORY_NAME);
    return async ({ qpqEventRecord }) => {
        switch (qpqEventRecord.eventType) {
            case EmailSendEventType.ResetPassword:
                return actionResult({
                    src: userDirectoryConfig?.emailTemplates.resetPassword?.src,
                    runtime: userDirectoryConfig?.emailTemplates.resetPassword?.runtime,
                });
            case EmailSendEventType.ResetPasswordAdmin:
                return actionResult({
                    src: userDirectoryConfig?.emailTemplates.resetPasswordAdmin?.src,
                    runtime: userDirectoryConfig?.emailTemplates.resetPasswordAdmin?.runtime,
                });
            case EmailSendEventType.VerifyEmail:
                return actionResult({
                    src: userDirectoryConfig?.emailTemplates.verifyEmail?.src,
                    runtime: userDirectoryConfig?.emailTemplates.verifyEmail?.runtime,
                });
            default:
                return actionResultError(ErrorTypeEnum.NotFound, `Email lambda not implemented for ${qpqEventRecord.eventType}`);
        }
    };
};
export default (qpqConfig) => {
    return {
        [EventActionType.MatchStory]: getProcessMatchStory(qpqConfig),
    };
};
