import { qpqCoreUtils } from 'quidproquo-core';
import { getKvsDynamoTableNameFromConfig } from '../../../awsNamingUtils';
import { actionResult, KeyValueStoreActionType, } from 'quidproquo-core';
import { updateItem } from '../../../logic/dynamo';
const getProcessKeyValueStoreUpdate = (qpqConfig) => {
    return async ({ keyValueStoreName, key, sortKey, updates, options }) => {
        const dynamoTableName = getKvsDynamoTableNameFromConfig(keyValueStoreName, qpqConfig, 'kvs');
        const region = qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig);
        const storeConfig = qpqCoreUtils.getKeyValueStoreByName(qpqConfig, keyValueStoreName);
        const item = await updateItem(dynamoTableName, region, updates, storeConfig.partitionKey.key, key, sortKey);
        return actionResult(item);
    };
};
export default (qpqConfig) => ({
    [KeyValueStoreActionType.Update]: getProcessKeyValueStoreUpdate(qpqConfig),
});
