import { actionResult, qpqCoreUtils, UserDirectoryActionType, } from 'quidproquo-core';
import { verifyUserEmail } from '../../../logic/cognito/verifyUserEmail';
const getUserDirectoryConfirmEmailVerificationActionProcessor = (qpqConfig) => {
    return async ({ code, accessToken }) => {
        const region = qpqCoreUtils.getApplicationModuleDeployRegion(qpqConfig);
        await verifyUserEmail(region, accessToken, code);
        return actionResult(void 0);
    };
};
export default (qpqConfig) => {
    return {
        [UserDirectoryActionType.ConfirmEmailVerification]: getUserDirectoryConfirmEmailVerificationActionProcessor(qpqConfig),
    };
};
